var YM = {
	currentContext: null,
	contexts: [],
	loadingFrame: false,
	boolPrefNames: ["disabled", "blink", "showtext","highOpacity", "mediumOpacity", "lowOpacity"],
	/*  +============================================+  */
	/*  | initialize:                                |  */
	/*  | resets all page values and gets page data  |  */
	/*  +============================================+  */
	initialize: function(e) {
		//initalization code
		this.initalized = true;
		this.pageData = null;
		this.serializedData = null;
		this.platform =  Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;
		this.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch2);
		this.prefs.addObserver("extensions.yourminis", YourminisPrefsObserver, false);
		this.initBoolPrefs(this.boolPrefNames);
		this.setOpacity();
		var tabBrowser = document.getElementById("content");
		tabBrowser.addProgressListener(YMTabProgressListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
		var container = tabBrowser.mPanelContainer;
		container.addEventListener("select", YM.tabSelected, false);
		this.disable(this.getBoolPref("disabled"));
		this.isDisabled = YM.disabled;
	},
	tabSelected: function() {
		
	},
	createContext: function(win){
		var browser = this.getBrowserByWindow(win);
		var context = {
			window: win,
			browser: browser,
			ymFrame: null,
			data: null,
			serializedData: null,
			uid: null,
			imageDiv: null
		};
    	context.onUnload = function(event) { YM.detachFromWindow(win); }
		win.addEventListener("unload", context.onUnload, true);
        this.attachToLoadingWindow(win, context);
        this.contexts.push(context);
    	return context;
	},
	destroyContext: function(context){
		var win = context.window;
		win.removeEventListener("unload", context.onUnload, true);
		if (this.contexts){
			var spliceIndex = -1;
			for(var i = 0; i < this.contexts.length; i++){
				if(this.contexts[i] == context) {
					spliceIndex = 0;
				}
			}
			if(spliceIndex >= 0)
				this.contexts.splice(spliceIndex,1);
		}
	},
	getContextByWindow: function(source){
		for (var i = 0; i < this.contexts.length; ++i)
		{
			var context = this.contexts[i];
			if (context.window == source)
				return context;
		}
		return null;
	},
	detachFromWindow: function(win){
		var context = this.getContextByWindow(win);
		if (!context)
			return;
		this.destroyContext(context);
	},
	initData: function(){
		try{
			this.getPageData(this.currentContext);
			this.setStatus();
		}catch(e){}
	},
	setStatus: function() {
		try{
			var data = this.currentContext.data;
			if(YM.showtext){
				if(data.rss.length > 0 ) {
					document.getElementById("my-panel").label = data.rss.length + " RSS Feed";
					if(data.rss.length > 1) {
						document.getElementById("my-panel").label += "s";
					}
				}
				if(data.video != "" && data.vids.length <= 0) {
					document.getElementById("my-panel").label += " 1 Video"
				}else if(data.vids.length > 0 && data.video != ""){
					document.getElementById("my-panel").label += (data.vids.length + 1)+"Videos"
				}else if(data.vids.length > 0){
					document.getElementById("my-panel").label += " "+data.vids.length+ " Video";
					if(data.vids.length > 1);
						document.getElementById("my-panel").label += "s";
				}
				if(data.events.length > 0){
					document.getElementById("my-panel").label += " "+data.events.length+ " Event";
					if(data.events.length > 1)
						document.getElementById("my-panel").label += "s";
				}
				if(data.contacts.length > 0 ){
					document.getElementById("my-panel").label += " "+data.contacts.length+ " Contact";
					if(data.contacts.length > 1)
						document.getElementById("my-panel").label += "s";
				}
				if(data.mp3s.length > 0){
					document.getElementById("my-panel").label += " "+data.mp3s.length+ " MP3";
					if(data.mp3s.length > 1)
						document.getElementById("my-panel").label += "s";
				}
				if(data.imgs.length > 0){
					document.getElementById("my-panel").label += " "+data.imgs.length+ " Photo";
					if(data.imgs.length > 1)
						document.getElementById("my-panel").label += "s";
				}
				if(data.profile != "") {
					document.getElementById("my-panel").label += " 1 Profile";
				}
			}
			if(data.rss.length > 0 || data.video != "" || data.events.length > 0 || data.contacts.length > 0 || data.mp3s.length > 0 || data.imgs.length > 0 || data.profile != "") {
				window.clearInterval(this.blinkInterval);
				YM.blinkInterval = null;
				document.getElementById("my-panel").src = "chrome://yourminishud/content/images/widgets.png";
				if(YM.blink){
					
					this.blinkInterval = window.setInterval(YM.blinkIcon,800);
				}else{
					document.getElementById("my-panel").src="chrome://yourminishud/content/images/widgets_highlight.png";
				}
			}
		}catch(e){}
	},
	/*  +============================================+  */
	/*  | uninitialize:                              |  */
	/*  | basically just stops the blinking          |  */
	/*  +============================================+  */
	uninitalize: function(e) {
		if(!YM.isDisabled)
			YM.stopBlinkIcon();
	},
	/*  +============================================+  */
	/*  | blinkIcon:                                 |  */
	/*  | starts blinking the extension icon         |  */
	/*  +============================================+  */
	blinkIcon: function() {
		icon = (document.getElementById("my-panel").src.indexOf("highlight") < 0)?"chrome://yourminishud/content/images/widgets_highlight.png":"chrome://yourminishud/content/images/widgets.png";
		document.getElementById("my-panel").src = icon;
	},
	/*  +============================================+  */
	/*  | stopBlinkIcon:                             |  */
	/*  | stops the blinking of the extension icon   |  */
	/*  +============================================+  */
	stopBlinkIcon: function() {
		window.clearInterval(YM.blinkInterval);
		YM.blinkInterval = null;
		document.getElementById("my-panel").src = "chrome://yourminishud/content/images/widgets.png";
	},
	/*  +============================================+  */
	/*  | serialize:                                 |  */
	/*  | serializes the pageData into xml           |  */
	/*  +============================================+  */
	serialize: function(data){
		var sd = "<data><location>"+data.location+"</location>";
		sd+="<rssfeeds>";
		for(var i = 0; i < data.rss.length; i++) {
			sd+="<rssfeed title=\""+escape(data.rss[i].title)+"\" href=\""+escape(data.rss[i].href)+"\" />";
		}
		sd+="</rssfeeds>";
	
			sd+="<youtubevideos>";
			if(data.video != "") {
				sd+="<youtubevideo title=\""+escape(data.video.title)+"\" href=\""+escape(data.video.href)+"\" />";
			}
			if(data.vids.length > 0){
				for(var i = 0; i < data.vids.length; i++){
					sd+="<youtubevideo id=\""+escape(data.vids[i])+"\"/>";
				}
			}
			sd+="</youtubevideos>";
		sd+="<events>";
		for(var i = 0; i < data.events.length; i++){
			sd+="<event title=\""+escape(data.events[i].summary)+"\" date=\""+escape(data.events[i].dtstart_str)+"\" location=\""+escape(data.events[i].location)+"\">";
			sd+=escape(data.events[i].vcal);
			sd+="</event>";
		}
		sd+="</events>";
		sd+="<contacts>";
		for(var i = 0; i < data.contacts.length; i++){
			sd+="<contact fn=\""+escape(data.contacts[i].fn)+"\" email=\""+escape(data.contacts[i].email)+"\" org=\""+escape(data.contacts[i].org)+"\" url=\""+escape(data.contacts[i].url)+"\">";
			sd+=escape(data.contacts[i].vCard);
			sd+="</contact>";
		}
		sd+="</contacts>";
		sd+="<mp3s>";
		for(var i = 0; i < data.mp3s.length; i++){
			sd+="<mp3 href=\""+escape(data.mp3s[i])+"\"/>";
		}
		sd+="</mp3s>";
		sd+="<imgs>";
		for(var i = 0; i < data.imgs.length; i++){
			sd+="<img img=\""+escape(data.imgs[i].img)+"\" thumb=\""+escape(data.imgs[i].thumb)+"\" site=\""+escape(data.imgs[i].site)+"\" />";
		}
		sd+="</imgs>";
		sd+="<profiles>";
		if(data.profile != "") {
			sd+="<profile name=\""+escape(this.cleanString(data.profile.name))+"\" img=\""+escape(data.profile.img)+"\" site=\""+escape(data.profile.site)+"\" />";
		}
		sd+="</profiles>";
		sd+="</data>";
		return sd;
	},
	/*  +============================================+  */
	/*  | getPageData                                |  */
	/*  | gets all relevant information about the    |  */
	/*  | page                                       |  */
	/*  +============================================+  */
	getPageData: function(context) {
		try{
		var url = this.currentContext.browser.contentDocument.URL;
		var vid = "";
		var profile = "";
		var name="";
		var img = "";
		if(url.indexOf("youtube.com/watch?") >= 0 ){
			var video_title = window._content.document.getElementsByTagName('H1').item(0).textContent;
			var video_url = "http://www.youtube.com"+window._content.document.getElementById('movie_player').src.replace("/player2.swf","/get_video");
			vid = {title:video_title,href:video_url};
		}
		if(url.indexOf("facebook.com/profile.php?id=") >= 0){
			//getname
			name = this.currentContext.browser.contentDocument.getElementById("profilepagewidecolumn").firstChild.firstChild.firstChild.firstChild.nodeValue;
			//getimage
			img = this.currentContext.browser.contentDocument.getElementById("profilenarrowcolumn").firstChild.firstChild.src;
			profile = {name:name,img:img,site:"facebook"};
		}
		if(url.indexOf("profile.myspace.com") >= 0 || (url.indexOf("myspace.com/") >= 0 && url.indexOf(".",url.indexOf("myspace.com/")+17) == -1 && url.indexOf("/",url.indexOf("myspace.com/")+17) == -1)) {
			//getname
			name = this.getElementsByClassName(this.currentContext.browser.contentDocument,"*","nametext")[0].firstChild.nodeValue;
			//getimage
			img = this.currentContext.browser.contentDocument.getElementById("ctl00_Main_ctl00_UserBasicInformation1_hlDefaultImage").firstChild.src;
			profile = {name:name,img:img,site:"myspace"}
		}
		if(url.indexOf("bebo.com/Profile.jsp") >= 0) {
			//getname
			name = this.getElementsByClassName(this.currentContext.browser.contentDocument,"*","profilePagetitle")[0].firstChild.nodeValue;
			name = name.substring(0,name.indexOf("<"));
			//getimage
			img = this.currentContext.browser.contentDocument.getElementsByTagName("div")[0].getElementsByTagName("table")[9].getElementsByTagName("img")[8].src;
			profile = {name:name,img:img,site:"bebo"};
		}
		if(url.indexOf("bebo.com/grp/Grp.jsp") >= 0){
			name = this.getElementsByClassName(this.currentContext.browser.contentDocument,"*","profilePagetitle")[0].firstChild.nodeValue;
			name = name.substring(0,name.indexOf("<"));
			//getimage
			img = this.getElementsByClassName(this.currentContext.browser.contentDocument,"*","m_c")[6].firstChild.src;
			profile = {name:name,img:img,site:"bebo"};
		}
		if(url.indexOf("www.friendster.com") >= 0 && url.indexOf(".php") == -1 && url.indexOf("/friends/") == -1) {
			//getname
			var fullnames = this.getElementsByClassName(this.currentContext.browser.contentDocument,"*","fullname1");
			if(fullnames[0].getElementsByTagName("a")[1]){
				name = fullnames[0].getElementsByTagName("a")[1].firstChild.nodeValue;
			}else{
				name = fullnames[0].getElementsByTagName("a")[0].firstChild.nodeValue;
			}
			//getimage
			img = this.currentContext.browser.contentDocument.getElementById("mainimage").src;
			profile = {name:name,img:img,site:"friendster"};
		}
		if(url.indexOf("tagworld.com/") >= 0 && url.indexOf("tagworld.com/-/") == -1) {
			//getname
			name = this.getElementsByClassName(this.currentContext.browser.contentDocument,"*","twheader4")[0].firstChild.nodeValue;
			//getimage
			var tries = this.getElementsByClassName(this.currentContext.browser.contentDocument,"*","sectionbody");
			for(var i = 0; i < tries.length; i++){
				if(tries[i].getElementsByTagName("img")[0]){
					img = tries[i].getElementsByTagName("img")[0].src;
					break;
				}
			}
			profile = {name:name,img:img,site:"tagworld"};
		}
		var vids = this.findVideos();
		var feeds = this.findFeeds(window._content.document);
		var events = this.getEvents();
		var contacts = this.getContacts();
		var imgs = this.getImages();
		var mp3s = this.findMP3s();
		var data = {location:url,rss:feeds,video:vid,vids:vids,events:events,contacts:contacts,mp3s:mp3s,imgs:imgs,profile:profile};
		}catch(e){}
		context.data = data;
		context.serializedData = YM.serialize(data);
		
		
	},
	getElementsByClassName: function(oElm, strTagName, oClassNames){
		var arrElements = (strTagName == "*" && oElm.all)? oElm.all : oElm.getElementsByTagName(strTagName);
		var arrReturnElements = new Array();
		var arrRegExpClassNames = new Array();
		if(typeof oClassNames == "object"){
			for(var i=0; i<oClassNames.length; i++){
				arrRegExpClassNames.push(new RegExp("(^|\\s)" + oClassNames[i].replace(/\-/g, "\\-") + "(\\s|$)"));
			}
		}
		else{
			arrRegExpClassNames.push(new RegExp("(^|\\s)" + oClassNames.replace(/\-/g, "\\-") + "(\\s|$)"));
		}
		var oElement;
		var bMatchesAll;
		for(var j=0; j<arrElements.length; j++){
			oElement = arrElements[j];
			bMatchesAll = true;
			for(var k=0; k<arrRegExpClassNames.length; k++){
				if(!arrRegExpClassNames[k].test(oElement.className)){
					bMatchesAll = false;
					break;                      
				}
			}
			if(bMatchesAll){
				arrReturnElements.push(oElement);
			}
		}
		return (arrReturnElements)
	},
	checkFeeds: function(arr,url){
		for(var i in arr)
			if(arr[i].href == url)
				return false;
		return true;
	},
	/*  +============================================+  */
	/*  | findFeeds:                                 |  */
	/*  | gets the rss feeds for a page              |  */
	/*  +============================================+  */
	findFeeds: function(d){
		try{
			var rssFeeds = new Array();
			var links = d.getElementsByTagName("link");
			for( var i =0;  i < links.length; i++ ) {
				if(links[i].rel == "alternate" && (links[i].type == "application/rss+xml" || links[i].type == "application/atom+xml")){
					if(this.checkFeeds(rssFeeds,links[i].href))
						rssFeeds.push({title:links[i].title,href:links[i].href});
				}
			}
			return rssFeeds;
		}catch(e){return false;}
	},
	checkEvents: function(arr,data){
		for(var i in arr)
			if(arr[i].vcal == data)
				return false;
		return true;
	},
	/*  +============================================+  */
	/*  | findMP3s:                                  |  */
	/*  | gets the mp3s on a page and passes them    |  */
	/*  | to the parser                              |  */
	/*  +============================================+  */
	findMP3s: function() {
		try{
		var mp3s = new Array();
		var links = window._content.document.getElementsByTagName("a");
		for( var i = 0; i < links.length; i++) {
			if(links[i].href.indexOf(".mp3") >= 0 && links[i].href.indexOf(".mp3.com") == -1){
				mp3s.push(YM.cleanURL(links[i].href));
			}
		}
		return mp3s;
		}catch(e){}
	},
	getImages: function() {
		var url = this.currentContext.browser.contentDocument.URL;
		var images = this.currentContext.browser.contentDocument.images;
		var imgs = new Array();
		
		//flickr
		if(url.indexOf("flickr.com") >= 0){
			for(var i =0; i < images.length; i++){ 
				var img = images[i];
				if(img.src.indexOf("static.flickr.com") >= 0 && img.src.indexOf("buddyicons") == -1){
					var jpgStart = img.src.indexOf(".jpg");
					var imgstr = img.src.substring(0,(jpgStart-2));
					//imgs.push({img:imgstr+".jpg",thumb:imgstr+"_s.jpg",site:"flickr"}); //this is for only using medium image, not image you're on.
					imgs.push({img:img.src,thumb:imgstr+"_s.jpg",site:"Flickr"});
				}
			}
		}
		
		//photobucket
		if(url.indexOf("photobucket.com") >= 0){
			for(var i =0; i < images.length; i++){ 
				var img = images[i];
				if(img.src.indexOf("albums") >= 0 && img.src.indexOf("pic.photobucket.com") == -1){
					var imgstr = "";
					var lastSlash = img.src.lastIndexOf("/");
					var thumb = "";
					if(img.src.substr(lastSlash+1,3) == "th_"){
						thumb = img.src;
						imgstr = img.src.split("th_")[0]+img.src.split("th_")[1];
					}else{
						imgstr = img.src;
						var fp = img.src.substring(0,img.src.lastIndexOf("/")+1);
						var lp = img.src.substr(img.src.lastIndexOf("/")+1,img.src.length);
						thumb = fp+"th_"+lp;
					}
					imgs.push({img:img.src,thumb:thumb,site:"Photobucket"}); //use imgstr for using medium image all the time instead of what you're on
				}
			}
		}
		
		//picasa
		if(url.indexOf("picasaweb.google.com") > 0){
			for(var i =0; i < images.length; i++){ 
				var img = images[i];
				if(img.src.indexOf("imgmax") >= 0 && img.src.indexOf("img/") == -1 & img.src.indexOf("crop=") == -1){
					var lastEQ = img.src.lastIndexOf("=");
					var imgstr = img.src.substring(0,lastEQ+1)+"576";
					var thumb = img.src.substring(0,lastEQ+1)+"72";
					imgs.push({img:img.src,thumb:thumb,site:"Picasa"}); //use imgstr for using medium image all the time instead of what you're on
				}
			}
		}
		
		//facebook
		if(url.indexOf("facebook.com") > 0 ) {
			for(var i =0; i < images.length; i++){ 
				var img = images[i];
				if(img.src.indexOf("photos-") >= 0 ){
					var lastSlash = img.src.lastIndexOf("/");
					if(img.src.charAt(lastSlash+1) == "s") {
						var thumb = img.src;
						var imgstr = img.src.substring(0,lastSlash+1)+"n"+img.src.substring(lastSlash+2,img.src.length);
					}else{
						var thumb = img.src.substring(0,lastSlash+1)+"s"+img.src.substring(lastSlash+2,img.src.length);
						var imgstr = img.src;
					}
					imgs.push({img:img.src,thumb:thumb,site:"Facebook"}); //use imgstr for using medium image all the time instead of what you're on
				}
			}
		}
		
		//myspace
		if(url.indexOf("viewmorepics.myspace.com") > 0) {
			for(var i =0; i < images.length; i++){ 
				var img = images[i];
				if(img.src.indexOf(".vo.llnwd.net") >= 0 ){
					fp = img.src.split("_");
					imgstr = fp[0]+"_l.jpg";
					thumb = fp[0]+"_s.jpg";
					imgs.push({img:img.src,thumb:thumb,site:"MySpace"}); //use imgstr for using medium image all the time instead of what you're on
				}
			}
		}
		
		//webshots
		if(url.indexOf("webshots.com") > 0) {
			if(this.currentContext.browser.contentDocument.getElementById("hqimage")){
				var src = this.currentContext.browser.contentDocument.getElementById("hqimage").src;
				var lastEQ = src.lastIndexOf("=");
				var imgURL = unescape(src.substring(lastEQ+1,src.length));
				var inputValue = this.currentContext.browser.contentDocument.getElementsByTagName("input")[9].value;
				var start = inputValue.indexOf("src=")+5;
				var end = inputValue.indexOf(" ",start)-1;
				var thumb = inputValue.substring(start,end);
				imgs.push({img:imgURL,thumb:thumb,site:"Webshots"});
			}else {
				for(var i =0; i < images.length; i++){ 
					var img = images[i];
					if(img.src.indexOf("webshots.net/") >= 0 && img.src.indexOf("thumb") >= 0 && img.src.indexOf("p.webshots.net/") == -1){
						imgs.push({img:img.src,thumb:img.src,site:"webshots"}); //use imgstr for using medium image all the time instead of what you're on
					}
				}
			}
		}
		
		//yahoo
		if(url.indexOf("pg.photos.yahoo.com") >= 0 ) {
			for(var i =0; i < images.length; i++){ 
				var img = images[i];
				if(img.src.indexOf("__tn_") >= 0 || img.src.indexOf("__sr_") >= 0){
					imgs.push({img:img.src,thumb:img.src,site:"Yahoo"}); //use imgstr for using medium image all the time instead of what you're on
				}
			}
		}
		
		//Kodak
		if(url.indexOf("kodakgallery.com") >= 0) {
			for(var i =0; i < images.length; i++){ 
				var img = images[i];
				if(img.src.indexOf("http://images.kodakgallery.com/photos") >= 0){
					if(img.src.indexOf("_SM.jpg") >= 0){
						imgs.push({img:img.src,thumb:img.src,site:"Kodak"}); //use imgstr for using medium image all the time instead of what you're on
					}else if(img.src.indexOf("_ALB.jpg") >= 0){
						var thumb = img.src.substring(0,img.src.length-7)+"SM.jpg";
						imgs.push({img:img.src,thumb:thumb,site:"Kodak"}); //use imgstr for using medium image all the time instead of what you're on
					}
				}
			}
		}
		return imgs;
	},
	/*  +============================================+  */
	/*  | findVideos:                                |  */
	/*  | gets the youtube videos on a page and      |  */
	/*  | passes them to the parser                  |  */
	/*  +============================================+  */
	findVideos: function() {
		try{
		var vids = new Array();
		var objects = window._content.document.getElementsByTagName("embed");
		for( var i = 0; i < objects.length; i++) {
			var src = objects[i].src;
			if(src.indexOf("youtube") >= 0 ){
			 var slash = src.lastIndexOf("/")+1;
			 var id = src.substring(slash,src.length)
			vids.push(id);
			}
		}
		return vids;
		}catch(e){}
	},
	
	/*  +============================================+  */
	/*  | getEvents:                                 |  */
	/*  | gets the vevents on a page and passes them |  */
	/*  | to the parser                              |  */
	/*  +============================================+  */
	getEvents: function() {
		var events = new Array();
		var eventArray = this.getElementsByClassName(window._content.document,"*","vevent");
		for(var i = 0; i < eventArray.length; i++){
			var event = YM.hCalendar(eventArray[i]);
			if(this.checkEvents(events,event.vcal))
				events.push(event);
		}
		return events;
	},
	checkContacts: function(arr,data){
		for(var i in arr)
			if(arr[i].vCard == data)
				return false;
		return true;
	},
	/*  +============================================+  */
	/*  | getContacts:                               |  */
	/*  | gets the vcards on a page and passes them  |  */
	/*  | to the parser                              |  */
	/*  +============================================+  */
	getContacts: function(){
		try{
		var contacts = new Array();
		var contactArray = this.getElementsByClassName(window._content.document,"*","vcard");
		for(var i = 0; i < contactArray.length; i++){
			var contact = YM.hCard(contactArray[i]);
			if(this.checkContacts(contacts,contact.vCard))
				contacts.push(contact);
		}
		return contacts;
		}catch(e){return [];}
	},
	/*  +============================================+  */
	/*  | cleanEmail:                                |  */
	/*  | cleans email addresses                     |  */
	/*  +============================================+  */
	cleanEmail: function(e) {
		e = e.replace('mailto:', '');
		return e.replace(/\?.*$/, '');
	},
	/*  +============================================+  */
	/*  | cleanURL:                                  |  */
	/*  | cleans urls                                |  */
	/*  +============================================+  */
	cleanURL: function(u) {
		if (!u.match(/^http/)) {
			if (u.match(/^\//))	u = window._content.document.location.protocol + '//' + window._content.document.location.hostname + u;
			else {
				var parts = window._content.document.location.pathname.split('/');
				parts.pop();
				var p = parts.join('/');
				u = window._content.document.location.protocol + '//' + window._content.document.location.hostname + p + '/' + u;
			}
		}
		return u;		
	},
	text: function(e) {
		e = e || this;
		var t = "";
		for ( var j = 0; j < e.length; j++ ) {
			var r = e[j].childNodes;
			for ( var i = 0; i < r.length; i++ )
				if ( r[i].nodeType != 8 )
					t += r[i].nodeType != 1 ?
						r[i].nodeValue : this.text([ r[i] ]);
		}
		return t;
	},

	/*  +============================================+  */
	/*  | cleanString:                               |  */
	/*  | cleans strings                             |  */
	/*  +============================================+  */
	cleanString: function(s) {
		s = s.replace(/^\s+/, '');
		s = s.replace(/\s+$/, '');
		s = s.replace(/( )+/g, ' ');
		return s.replace(/\n/g, '\n'); // plain text!
	},
	/*  +============================================+  */
	/*  | hCalendar:                                 |  */
	/*  | parses vevents                             |  */
	/*  +============================================+  */
	hCalendar: function(ve) {
		var hCal = {};
		var keys = ['summary', 'location', 'description', 'attendee', 'contact', 'organizer'] ;
		for (var i = 0; i < keys.length; i++) {
			if(this.getElementsByClassName(ve,"*",keys[i]).length) hCal[keys[i]] = YM.cleanString(this.text(this.getElementsByClassName(ve,"*",keys[i])));
		}
		// collect adr manually
		if (this.getElementsByClassName(ve,"*","adr").length.length) {
			var keys = ['post-office-box', 'extended-address', 'street-address', 'locality', 'region', 'postal-code', 'country-name'];
			for (var i = 0; i < keys.length; i++) {
				if(this.getElementsByClassName(ve,"*",keys[i]).length) hCal[keys[i]] = YM.cleanString(this.text(this.getElementsByClassName(ve,"*",keys[i])));
				hCal.adr = 1;
			}
		}
		keys = ['dtstart', 'dtend', 'duration'];
		for (var i = 0; i < keys.length; i++) {
			if(this.getElementsByClassName(ve,"*",keys[i]).length) hCal[keys[i]] = this.getElementsByClassName(ve,"*",keys[i])[0].title;
		}
		// how wasteful am I?!
		try{
		if (hCal.dtstart) hCal.dtstart_raw = cleanDateTime(hCal.dtstart);
		if (hCal.dtstart_raw) hCal.dtstart = hCal.dtstart_raw.formatted();
		if (hCal.dtstart_raw) hCal.dtstart_str = hCal.dtstart_raw.toString();
		if (hCal.dtend) hCal.dtend_raw = cleanDateTime(hCal.dtend);
		if (hCal.dtend_raw) hCal.dtend = hCal.dtend_raw.formatted();
		if (hCal.dtend_raw) hCal.dtend_str = hCal.dtend_raw.toString();
		}catch(e){}
		if(this.getElementsByClassName(ve,"*","url").length) hCal.url =   this.getElementsByClassName(ve,"*","url")[0].href;
		if (hCal.url) hCal.url = YM.cleanURL(hCal.url);
		if (hCal.description) hCal.description = hCal.description.replace(/\n/g, '\n');
		var note = 'Source: ' + location.hostname;
		if (hCal.description) hCal.description += '\n' + note;
		else hCal.description = note;
		this.vCalendar = function() {
			var nl = '%0D%0A';
			vcal = 'data:text/calendar;utf-8,';
			vcal += 'BEGIN:VCALENDAR'+ nl + 'BEGIN:VEVENT' + nl;	
			if (hCal.adr) {
				var keys = ['post-office-box', 'extended-address', 'street-address', 'locality', 'region', 'postal-code', 'country-name'];
				hCal.location = '';
				for (var i = 0; i < keys.length; i++) {
					if (hCal[keys[i]]) { 
						if (keys[i] == 'locality') hCal.location += '\n';
						hCal.location += hCal[keys[i]] + ' ';
					}
				}
			}
			var keys = ['summary', 'location', 'description', 'attendee', 'contact', 'organizer', 'dtstart', 'dtend', 'duration', 'note'];
			for (var i = 0; i < keys.length; i++) {
				if (hCal[keys[i]]) vcal += keys[i].toUpperCase() + ':' + encodeURIComponent(hCal[keys[i]]) + nl;
			}
			vcal += 'END:VEVENT' + nl + 'END:VCALENDAR';
			return vcal;
		}
		hCal.vcal = this.vCalendar();
		return hCal;
	},
	/*  +============================================+  */
	/*  | hCard:                                     |  */
	/*  | parses vcards                              |  */
	/*  +============================================+  */
	hCard: function(hc) {
		var hCard = {};
		var keys = ['fn', 'n', 'org', 'title', 'role', 'note', 'family-name', 'given-name', 'additional-name', 'honorific-prefix', 'honorific-suffix', 'nickname', 'category', 'note'];
		for (var i = 0; i < keys.length; i++) {
			if(this.getElementsByClassName(hc,"*",keys[i]).length) hCard[keys[i]] = YM.cleanString(this.text(this.getElementsByClassName(hc,"*",keys[i])));
		}
		// collect adr manually
		if (this.getElementsByClassName(hc,"*","adr").length) {
			var keys = ['post-office-box', 'extended-address', 'street-address', 'locality', 'region', 'postal-code', 'country-name'];
			for (var i = 0; i < keys.length; i++) {
				if(this.getElementsByClassName(hc,"*",keys[i]).length) hCard[keys[i]] = YM.cleanString(this.text(this.getElementsByClassName(hc,"*",keys[i])));
				hCard.adr = 1;
			}
		}
		hCard.tel = {};
		var tels = this.getElementsByClassName(hc,"*","tel");
		for( var i in tels) {
			var t = this.getElementsByClassName(tels[i],"*","type");
			if (t.length && t[0].title) t = t[0].title; // non-standard...?
			else if (this.text(t)) t = this.text(t);
			else t = 'Work';
			var v = this.text(this.getElementsByClassName(tels[i],"*","value"));
			if (!v) v = this.text(tels[i]);
			hCard.tel[t] = v;
		}
		// attribute based values
		if (this.getElementsByClassName(hc,"*","url").length) hCard.url = this.getElementsByClassName(hc,"*","url")[0].href;
		if (this.getElementsByClassName(hc,"*","email").length) hCard.email = this.getElementsByClassName(hc,"*","email")[0].href;
		if (this.getElementsByClassName(hc,"*","bday").length) hCard.bday = this.getElementsByClassName(hc,"*","bday")[0].title;
		// clean up
		if (hCard.email) hCard.email = YM.cleanEmail(hCard.email);
		if (hCard.url) hCard.url = YM.cleanURL(hCard.url);
		if (hCard.note) hCard.note = hCard.note.replace(/\n/g, '\n');
		var note = 'Source: ' + location.hostname;
		if (hCard.note) hCard.note += '\n' + note;
		else hCard.note = note;
		if (!hCard.fn && hCard.org) hCard.fn = hCard.org;
		this.vCard = function() {
			var nl = '%0D%0A';
			vcard = 'data:text/vcard;utf-8,';
			vcard += 'BEGIN:VCARD' + nl;	
			if (hCard.family-name) hCard.n = hCard.family-name;
			if (hCard.given-name) {
				if (hCard.n) hCard.n += ';';
				hCard.n += hCard.given-name;
			}
			if (hCard.adr) {
				var keys = ['post-office-box', 'extended-address', 'street-address', 'locality', 'region', 'postal-code', 'country-name'];
				hCard.adr = '';
				for (var i = 0; i < keys.length; i++) {
					if (hCard[keys[i]]) hCard.adr += hCard[keys[i]] + ';';
				}
			}
			if (!hCard.n) {				
				if (!hCard.n && hCard.fn && (hCard.fn.split(' ').length == 2)) {
					var parts = hCard.fn.split(' ')
					parts = parts.reverse();
					hCard.n = parts.join(';');
				}
			}
			var keys = ['fn', 'n' , 'org', 'title', 'role', 'note', 'nickname', 'adr', 'email', 'url', 'note', 'bday'];
			for (var i = 0; i < keys.length; i++) {
				if (hCard[keys[i]]) vcard += keys[i].toUpperCase() + ':' + encodeURIComponent(hCard[keys[i]]) + nl;
			}
			for (var key in hCard.tel) {
				vcard += 'TEL;' + key.toUpperCase() + ':' + hCard.tel[key] + nl;
			}			
			vcard += 'END:VCARD';
			return vcard;
		}
		hCard.vCard = this.vCard();
		return hCard;
	},
	
	/*  +============================================+  */
	/*  | createOverlay:                             |  */
	/*  | creates the iframe overaly, injects the    |  */
	/*  | localconnection bridge and the required    |  */
	/*  | javascript functions for externalinterface |  */
	/*  +============================================+  */
	createOverlay: function() {
		YM.loadingFrame = true;
		YM.destroyOverlay(true);
		try{
		//add image background first
		this.currentContext.imageDiv = this.currentContext.browser.contentDocument.createElement("div");
		this.currentContext.imageDiv.innerHTML = "<center style='position:absolute;top:50%;left:50%'><img src='chrome://yourminishud/content/images/ajax-loader.gif'></center>";
		this.currentContext.browser.contentDocument.body.appendChild(this.currentContext.imageDiv);
		this.currentContext.imageDiv.style.position="fixed";
		this.currentContext.imageDiv.style.top = "0px";
		this.currentContext.imageDiv.style.left = "0px";
		this.currentContext.imageDiv.style.backgroundColor = "#000000";
		this.currentContext.imageDiv.style.opacity = "."+YM.opacity;
		this.currentContext.imageDiv.style.width = "100%";
		this.currentContext.imageDiv.style.height = "100%";
		this.currentContext.imageDiv.style.zIndex = "999999998";
		this.currentContext.imageDiv.setAttribute("id","imageDiv");
		//inject extension data function
		var script = this.currentContext.browser.contentDocument.createElement("script");
		script.type = 'text/javascript';
		script.defer = true;
		script.text = "function hideLoader(){document.body.removeChild(document.getElementById('imageDiv'));}";
		script.text +="function getExtensionData(){return '"+this.currentContext.serializedData+"';}";
		if(YM.platform == "Darwin") {
			script.text +="function hideYMOverlay(){document.getElementById('YMFrame').style.visibility='hidden';showYMFlash();}";
			script.text +="function showYMFlash(){var flashes=document.embeds;for(var i=0;i<flashes.length;i++){flashes[i].style.visibility='visible';}var iframes=document.getElementsByTagName('iframe');for(var i=0;i<iframes.length;i++){if(iframes[i].id!='YMFrame')iframes[i].style.visibility='visible';}}";
		}else{
			script.text +="function hideYMOverlay(){document.getElementById('YMFrame').style.visibility='hidden';}";
		}
		var head = this.currentContext.browser.contentDocument.getElementsByTagName('head').item(0);
		head.appendChild(script);
		// add localconnection bridge
		var uid = new Date().getTime();
		this.currentContext.uid = uid;
		this.currentContext.browser.contentDocument.body.innerHTML += '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0" width="0" height="0" id="YMbridge" name="YMbridge" align="middle"><param name="allowScriptAccess" value="always" /><param name="movie" value="'+YM_HOST+'/swfs/ymbridge.swf?YMGUID='+uid+'" /><param name="quality" value="high" /><param name="bgcolor" value="#ffffff" /><embed src="'+YM_HOST+'/swfs/ymbridge.swf?YMGUID='+uid+'" quality="high" bgcolor="#ffffff" width="0" height="0" name="YMbridge" id="YMbridge" align="middle" allowScriptAccess="always" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" />';
		//create overlay frame
		YM.startLoad = new Date();
		/*this.currentContext.browser.contentDocument.body.innerHTML += '<iframe src="'+YM_SERVERLOCATION+"&YMGUID="+uid+"&OPACITY="+YM.opacity+'" frameborder="0" style="position:fixed;top:0px;left:0px;width:100%;height:100%;z-index:999999999;visibility:visible;" id="YMFrame" name="YMFrame"></iframe>';
		this.currentContext.ymFrame = this.currentContext.browser.contentDocument.getElementById("YMFrame");
		this.currentContext.ymFrame.addEventListener('load', YM.doneLoadingIframe, false);*/
		this.currentContext.ymFrame = this.currentContext.browser.contentDocument.createElement("IFRAME"); 
		this.currentContext.ymFrame.addEventListener('load', YM.doneLoadingIframe, false);
		this.currentContext.ymFrame.frameBorder = 0;
		this.currentContext.ymFrame.src = YM_SERVERLOCATION+"&YMGUID="+uid+"&OPACITY="+YM.opacity;
		this.currentContext.browser.contentDocument.body.appendChild(this.currentContext.ymFrame);
		this.currentContext.ymFrame.style.position="fixed"; 
		this.currentContext.ymFrame.style.top="0px";
		this.currentContext.ymFrame.style.left="0px"; 
		this.currentContext.ymFrame.style.width="100%"; 
		this.currentContext.ymFrame.style.height="100%";
		this.currentContext.ymFrame.style.zIndex="999999999";
		this.currentContext.ymFrame.style.display = "block"
		this.currentContext.ymFrame.setAttribute("name","YMFrame");
		this.currentContext.ymFrame.setAttribute("id","YMFrame");
		}catch(e){}
	},
	destroyOverlay: function(all) {
		var tabBrowser = document.getElementById("content");
		for (var i = 0; i < tabBrowser.browsers.length; i++){
			var browser = tabBrowser.browsers[i];
			if(all){
				try{
					browser.contentDocument.body.removeChild(browser.contentDocument.getElementById('YMFrame'));
					browser.contentDocument.body.removeChild(browser.contentDocument.getElementById('YMbridge'));
				}catch(e){}
			}else{
				if (browser !=  tabBrowser.selectedBrowser){
					try{
						browser.contentDocument.body.removeChild(browser.contentDocument.getElementById('YMFrame'));
						browser.contentDocument.body.removeChild(browser.contentDocument.getElementById('YMbridge'));
					}catch(e){}
				}
			}
		}
	},
	doneLoadingIframe: function() {
		try{
		YM.loadingFrame = false;
		var doneLoad = new Date();
		//alert("Took "+(doneLoad - YM.startLoad)+"ms to load iframe.");
		}catch(e){}
	},
	/*  +============================================+  */
	/*  | createOverlay:                             |  */
	/*  | creates the iframe overaly, injects the    |  */
	/*  | localconnection bridge and the required    |  */
	/*  | javascript functions for externalinterface |  */
	/*  +============================================+  */
	toggleYM: function() {
		if(!YM.disabled){
		if(!this.currentContext.loaded)
			return;
		try{
			YM.stopBlinkIcon();
			if(this.currentContext.ymFrame == null || this.currentContext.ymFrame.contentDocument == undefined ){
				if (YM.platform == "Darwin"){
					YM.hideFlash();
				}
				YM.createOverlay();
			}else if(this.currentContext.ymFrame.style.visibility != "hidden"){
				if (YM.platform == "Darwin")
					YM.showFlash();
				this.currentContext.ymFrame.style.visibility = "hidden";
			}else{
				this.currentContext.ymFrame.style.visibility = "visible";
				if (YM.platform == "Darwin") {
					YM.hideFlash();
					this.currentContext.ymFrame.style.top = "0px";
				}
			}
		}catch(e){}
		}
	},
	hideFlash: function(){
		try{
			var flashes = this.currentContext.browser.contentDocument.embeds;
			for(var i = 0; i < flashes.length; i++){
				flashes[i].style.visibility = "hidden";
			}
			var iframes = this.currentContext.browser.contentDocument.getElementsByTagName("iframe");
			for(var i = 0; i < iframes.length; i++){
				if(iframes[i].id != "YMFrame")
					iframes[i].style.visibility = "hidden";
			}
		}catch(e){}
	},
	showFlash: function(){
		try{
			var flashes = this.currentContext.browser.contentDocument.embeds;
			for(var i = 0; i < flashes.length; i++){
				flashes[i].style.visibility = "visible";
			}
			var iframes = this.currentContext.browser.contentDocument.getElementsByTagName("iframe");
			for(var i = 0; i < iframes.length; i++){
				if(iframes[i].id != "YMFrame")
					iframes[i].style.visibility = "visible";
			}
		}catch(e){}
	},
	/*  +============================================+  */
	/*  | checkTabChange:                            |  */
	/*  | checks to see if the user has changed tabs |  */
	/*  | and reinitalizes the page data if the tab  |  */
	/*  | has changed                                |  */
	/*  +============================================+  */
	checkTabChange: function() {
		var selectedBrowser = document.getElementById("content").selectedBrowser;
		if(YM.currentBrowser != selectedBrowser){
			window.clearInterval(YM.checkTabInterval);
			YM.myFrame = null;
			YM.oldBrowser = YM.currentBrowser;
			YM.initialize(null);
		}
	},
	onOptionsPopup: function(popup){
		for (var child = popup.firstChild; child; child = child.nextSibling){
			var viewName = child.getAttribute("view");
			if (child.localName == "menuitem"){
				var option = child.getAttribute("option");
				if (!option)
					continue;
				var checked = false;
				for (var i in YM.boolPrefNames){
					var prefName = YM.boolPrefNames[i];
					if (prefName == option)	{
						checked = YM[prefName];
						break;
					}
				}		
				child.setAttribute("checked", checked);
			}
		}
	},
	toggleOption: function(menuitem){
		var checked = menuitem.getAttribute("checked") == "true";
		var option = menuitem.getAttribute("option");
		for (var i in YM.boolPrefNames)
		{
			var prefName = YM.boolPrefNames[i];
			if (prefName == option)
			{
				if(prefName == "disabled" || !YM[prefName])
				YM.setBoolPref(prefName, checked);
				YM.setOption(prefName, checked);
				break;
			}
		}
	},
	setOption: function(name,checked) {
		switch(name) {
			case "disabled":
				YM.disable(checked);
				break;
			case "blink" :
					YM.setBoolPref("blink",checked);
					this.setStatus();
				break;
			case "showtext" :
					YM.setBoolPref("showtext",checked);
					document.getElementById("my-panel").label = "";
					this.setStatus();
				break;
			case "highOpacity":
				if(checked){
					YM.opacity = 60;
					YM.setBoolPref("lowOpacity", false);
					YM.setBoolPref("mediumOpacity", false);
				}
				break;
			case "mediumOpacity":
				if(checked){
					YM.opacity = 80;
					YM.setBoolPref("lowOpacity", false);
					YM.setBoolPref("highOpacity", false);
				}
				break;
			case "lowOpacity":
				if(checked)
					YM.opacity = 95;
					YM.setBoolPref("highOpacity", false);
					YM.setBoolPref("mediumOpacity", false);
				break;
		}
		if(name == "highOpacity" || name == "mediumOpacity" || name == "lowOpacity") {
			if(this.currentContext){
				if(this.currentContext.ymFrame != null && this.currentContext.ymFrame.contentDocument != undefined){
					if(this.currentContext.ymFrame.style.visibility == "visible"  || this.currentContext.ymFrame.style.visibility == ""){
						this.currentContext.imageDiv.style.opacity = "."+YM.opacity;
						this.currentContext.browser.contentDocument.body.appendChild(this.currentContext.imageDiv);
					}
					this.currentContext.ymFrame.src = YM_SERVERLOCATION+"&YMGUID="+this.currentContext.uid+"&OPACITY="+YM.opacity;
				}
			}
		}
	},
	setOpacity: function() {
		if(YM.highOpacity){
			YM.opacity = 60;
		}else if(YM.mediumOpacity){
			YM.opacity = 80;
		}else{
			YM.opacity = 95;
		}
	},
	disable: function(d) {
		if(d != YM.isDisabled){
			YM.isDisabled = d;
			if(d){
				document.getElementById("my-panel").label = "";
				document.getElementById("my-panel").style.cursor = "";
				YM.destroyOverlay(true);
				for(var i in this.contexts){
					this.destroyContext(this.contexts[i]);
				}
				this.contexts = [];
			}else{
				YM.attachToWindow(window._content.window);
				document.getElementById("my-panel").style.cursor = "pointer";
				document.getElementById("my-panel").src = "chrome://yourminishud/content/images/widgets.png";
				YM.initData();
			}
		}
		if(d){
			YM.stopBlinkIcon();
			document.getElementById("my-panel").src = "chrome://yourminishud/content/images/widgets_disabled.png";
		}
	},
	initBoolPrefs: function(prefNames) {
		try{
			for (var i in prefNames){
				var prefName = prefNames[i];
				YM[prefName] = YM.prefs.getBoolPref("extensions.yourminis." + prefName);
			}
		}catch(e){}
	},
	getBoolPref: function(prefName){
		return YM.prefs.getBoolPref("extensions.yourminis." + prefName);
	},
	setBoolPref: function(prefName, value){
		YM[prefName] = value;
		YM.prefs.setBoolPref("extensions.yourminis." + prefName, value);
	},
	attachToWindow: function(win){
		if(this.isDisabled){
			return;
		}
		YM.attachedToWindow = false;
		YM.stopBlinkIcon();
		document.getElementById("my-panel").label = "";
		var context = this.getContextByWindow(win);
		if(!context)
			context = this.createContext(win);
		this.currentContext = context;
		if(context){
			if(!context.browser.attachedYM){
				context.browser.addProgressListener(YMFrameProgressListener,Components.interfaces.nsIWebProgress.NOTIFY_DOCUMENT);
				context.browser.attachedYM = true;
			}
			context.loaded = !context.browser.webProgress.isLoadingDocument;
			if(context.loaded){
				YM.initData();
			}else{	
				document.getElementById("ttipl1").value="Please wait while page loads.";
				document.getElementById("ttipl2").value="";
				document.getElementById("my-panel").src = "chrome://yourminishud/content/images/widgets_loading.gif";
			}
		}
		
	},
	getRootWindow: function(win) {
		for (; win; win = win.parent){
        if (!win.parent || win == win.parent)
            return win;
		}
		return null;
	},
	attachToLoadingWindow: function(win, context) {
		if(!context)
			var rootWindow = this.getRootWindow(win);
			context = this.getContextByWindow(rootWindow);
		if(!context) 
			return;
	},
	attachToLoadedWindow: function(win) {
		var context = this.getContextByWindow(win);
		if (!context || context.loaded)
			return;
		if(this.isDisabled)
			return;
		document.getElementById("my-panel").src = "chrome://yourminishud/content/images/widgets.png";
		document.getElementById("ttipl1").value="Click here to launch yourminis.";
		document.getElementById("ttipl2").value="Or press ctrl + ~ on your keyboard.";	
		this.initData();
		context.loaded = true;
	},
	getBrowserByWindow: function(win){
		var tabBrowser = document.getElementById("content");
		for (var i = 0; i < tabBrowser.browsers.length; ++i){
			var browser = tabBrowser.browsers[i];
			if (browser.contentWindow == win)
				return browser;
		}
       return null;
	}
}
/*  +============================================+  */
/*  | cleanDateTime:                             |  */
/*  | cleans date and time strings               |  */
/*  +============================================+  */
function cleanDateTime(t) {
	// 20060913T1400-0700
	// 2006-09-13T14:00-07:00
	pad = function(s) {
		if (s.length == 1) s = '0' + s;
		return s;
	}
	num = function(str, s, e) {
		return parseInt(str.substr(s, e), 10);
	}
	// strip formatting - currently doesn't support 2006-W05
	var endpos = t.indexOf('T');
	if (endpos == -1) endpos = t.length;
	var dstr = t.substr(0, endpos).replace(/\-/g, '');
	var tstr;
	if (endpos != t.length) tstr = t.substr(endpos+1).replace(/:/g, '');
	else tstr = '1200';
	t = dstr + 'T' + tstr;
	var d = new Date();
	d.setFullYear(num(dstr, 0, 4), num(dstr, 4, 2) - 1, num(dstr, 6, 2));
	d.setHours(num(t, 9, 2), num(t, 11, 2), 0); //  + offset
	var m = d.getMilliseconds();
	var offset = num(t, 14, 2) * 60 + num(t, 16, 2); // damn this is noddy.
	if (isNaN(offset) == false) {
		if (t.substr(13, 1) != '-') offset *= -1;
		m = m + (offset * 60 * 1000);
	}
	d.setMilliseconds(m);
	formatted = function(){
		var s = d.getFullYear().toString();
		s += pad((d.getMonth()+1).toString());
		s += pad(d.getDate().toString()) + 'T';
		s += pad(d.getHours().toString());
		s += pad(d.getMinutes().toString());
		s += pad(d.getSeconds().toString());
		if (offset) s += 'Z';
		return s;
	}
	toString = function() {
		return d.toString();
	}
	return this;
}
var YMEventListener = {
  handleEvent: function (event) {
  event.thisObject = YM;
  switch ( event.type ) {
    case "load":
			if(!YM.initalized)
				YM.initialize(event);
		break;
	case "unload":
		if(event.originalTarget.title == window._content.document.title) {
			document.getElementById("my-panel").label = "";
			YM.uninitalize(event);
			YM.pageData = null;
		}
		break;
   }
  }
};
///////////////////////////////////////////////////////////////////////////////////////////////////
function YMWebProgressListener(){}
YMWebProgressListener.prototype =
{
    stateIsRequest: false,
    QueryInterface : function(iid){
        if (iid.equals(Components.interfaces.nsIWebProgressListener) ||
            iid.equals(Components.interfaces.nsISupportsWeakReference) ||
            iid.equals(Components.interfaces.nsISupports)){
            return this;
        }
        throw Components.results.NS_NOINTERFACE;
    },
    onLocationChange: function(progress, request, location) { },
    onStateChange : function(progress, request, flag, status) {},
    onProgressChange : function(a,b,c, d,e,f) {},
    onStatusChange : function(a,b,c,d) {},
    onSecurityChange : function(a,b,c) {},
    onLinkIconAvailable : function(a) {} 
};
var YMTabProgressListener = new YMWebProgressListener();
YMTabProgressListener.onLocationChange = function(progress, request, location){
    // Only attach to windows that are their own parent - e.g. not frames
    if (progress.DOMWindow.parent == progress.DOMWindow)
       YM.attachToWindow(progress.DOMWindow);
}
YMTabProgressListener.onStateChange = function(progress, request, flag, status){
    // When the load of the top-level page completes
    if (flag & Components.interfaces.nsIWebProgressListener.STATE_STOP)
        YM.attachToLoadedWindow(progress.DOMWindow);
}
var YMFrameProgressListener = new YMWebProgressListener();
YMFrameProgressListener.onStateChange = function(progress, request, flag, status){
	// When the load of the top-level page or a frame within begins
	if (flag & Components.interfaces.nsIWebProgressListener.STATE_START)
        YM.attachToLoadingWindow(progress.DOMWindow);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
var YourminisPrefsObserver =
{
    observe: function(subject, topic, data){
        if (data == "extensions.yourminis.disabled")
            YM.disable(YM.getBoolPref("disabled"));
        else if (data == "extensions.yourminis.highOpacity"){}
        else if (data == "extensions.yourminis.mediumOpacity"){}
        else if (data == "extensions.yourminis.lowOpacity"){}
    }
};
window.addEventListener("keydown",function(e){if(e.ctrlKey && (e.keyCode == "192" || e.keyCode=="0")){YM.toggleYM();}},false);
window.addEventListener("unload", YMEventListener, true);
window.addEventListener("load", YMEventListener, true);